﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SampleData;
using Infragistics.Web.Mvc;

namespace UpdateData.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

		static DataUtil data = new DataUtil();

        public ActionResult Index()
        {
            return View();
        }

		[GridDataSourceAction]
		public ActionResult UpdatingGetData(object thing)
		{
			return View(data.Products.AsQueryable().OrderBy(o => o.ProductID));
		}

		public JsonResult SaveAllTheChanges(SampleData.MyModel viewData)
		{
			//	Handle grid data.
			GridModel m = new GridModel();
			List<Transaction<SampleData.Product>> transactions = m.LoadTransactions<SampleData.Product>(viewData.ig_transactions);

			foreach (Transaction<SampleData.Product> trans in transactions)
			{
				if (trans.type == "newrow")
				{
					data.AddProduct(trans.row);
				}
				else if (trans.type == "deleterow")
				{
					var product = (from p in data.Products
								   where p.ProductID == Int32.Parse(trans.rowId)
								   select p).Single();

					data.RemoveProduct(product);
				}
				else if (trans.type == "row")
				{
					data.UpdateProduct(trans.row);
				}
			}

			//	Handle form data.
			//	...

			//	Setup response.
			JsonResult result = new JsonResult();
			Dictionary<string, object> response = new Dictionary<string, object>();
			response.Add("Success", true);	//	Required to clear grid transactions on client.
			response.Add("result", "Updated!");
			result.Data = response;
			return result;
		}
    }
}
